<template>
  <div class="zong">
    <div style="display: flex">
      <el-select
        v-model="value"
        placeholder="请选择检查设备"
        @change="getMonitor"
      >
        <el-option
          v-for="item in options"
          :key="item.value"
          :label="item.label"
          :value="item.value"
        >
        </el-option>
      </el-select>
      <el-select
        v-model="value1"
        multiple
        collapse-tags
        style="margin-left: 20px"
        placeholder="请选择监测因子"
      >
        <el-option
          v-for="item in Monfactors"
          :key="item.value"
          :label="item.name"
          :value="item.code"
        >
        </el-option>
      </el-select>
      <el-date-picker
        v-model="startvalue"
        type="datetime"
        placeholder="选择开始日期时间"
        value-format="yyyy-MM-dd HH"
        style="margin-left: 20px"
      >
      </el-date-picker>
      <el-date-picker
        v-model="endvalue"
        type="datetime"
        placeholder="选择结束日期时间"
        value-format="yyyy-MM-dd HH"
        style="margin-left: 20px"
      >
      </el-date-picker>
      <el-button type="primary" @click="toExcel()" style="margin-left: 20px"
        >导出</el-button
      >
      <el-button @click="exportMon">查询</el-button>
    </div>

    <el-table
      :data="dateList"
      style="margin-top: 20px"
      id="exportTab"
      border
      max-height="800"
    >
      <el-table-column
        v-for="item in columnList"
        :prop="item"
        :label="item"
        width="180px"
        :key="item"
      >
      </el-table-column>
    </el-table>
  </div>
</template>
<script>
//这里可以导入其他文件（比如：组件，工具js，第三方插件js，json文件，图片文件等等）
// 例如：import《组件名称》from'《组件路径》';
import FileSaver from 'file-saver'
import XLSX2 from 'xlsx-style'
import XLSX from 'xlsx'
export default {
  //import 引入的组件需要注入到对象中才能使用
  components: {},
  props: {},
  data() {
    //这里存放数据
    return {
      value: '',
      value1: [],
      startvalue: '',
      endvalue: '',
      options: [],
      columnList: [], //表头的数组
      dateList: [],
      newMac1: [],
      Monfactors: [],
      tableData: [],
      tableFields: {},
      json_meta: [
        [
          {
            key: 'charset',
            value: 'utf-8',
          },
        ],
      ],
    }
  },
  // 计算属性 类似于data概念
  computed: {},
  // 监控data中的数据变化
  watch: {
    // value(one,two){
    //   this.newMac1=[]
    //    for (let i = 0; i < one.length; i++) {
    //     // console.log(newVal[i], 111)
    //     this.newMac1.push(one[i][1][1])
    //   }
    //    this.getSensor()
    // }
  },
  //方法集合
  name: 'exporName',
  methods: {
    getMonitor(res) {
      this.Monfactors = []
      this.$request({
        url: 'sensor/getSensorsByMonitorPointIds',
        method: 'get',
        params: {
          monitorPointIds: res,
        },
      }).then((res) => {
        console.log(res)
        this.Monfactors = res.data
      })
    },
    exportMon() {
      if (this.value === '') {
        this.$message.warning('请选择检查设备')
        return
      }
      if (this.value1 === '') {
        this.$message.warning('请选择因子')
        return
      }
      if (this.startvalue === '') {
        this.$message.warning('请选择开始时间')
        return
      }
      if (this.endvalue === '') {
        this.$message.warning('请选择结束时间')
        return
      }
      this.dateList = []
      this.columnList = []
      this.$request({
        url: '/monitorPoint/getHourlyDataByMonitorPoint',
        method: 'get',
        params: {
          monitorPointId: this.value,
          sensors: this.value1.toString(),
          startTime: this.startvalue,
          endTime: this.endvalue,
        },
      }).then((res) => {
        console.log(res, 11)
        this.tableData = res.data
        console.log(this.tableData, 'this.tableData')
        for (let key in this.tableData[0]) {
          this.columnList.push(key)
        }
        for (let item of this.tableData) {
          this.dateList.push(item)
        }
      })
      console.log(1)
    },
    getMonitorPointId() {
      this.$request({
        url: '/monitorPoint/queryAllMonitorPoints',
        method: 'get',
        params: {
          organizationId: this.$store.state.orgId,
        },
      })
        .then((res) => {
          // console.log('请求站点的信息')
          // console.log(res)
          for (let i = 0; i < res.data.length; i++) {
            this.options.push({
              value: res.data[i].id,
              label: res.data[i].name,
            })
          }
          console.log(this.options)
        })
        .catch((err) => {
          console.log(err)
        })
    },
    toExcel() {
      let wb = XLSX.utils.table_to_book(document.querySelector('#exportTab'), {
        sheet: '分组表',
      })
      this.setExlStyle(wb['Sheets']['分组表'])
      var ws = XLSX2.write(wb, {
        type: 'buffer',
      })
      try {
        FileSaver.saveAs(
          new Blob([ws], { type: 'application/octet-stream' }),
          `监测站点数据表.xlsx`
        )
      } catch (e) {
        if (typeof console !== 'undefined') console.log(e, ws)
      }
      return ws
    },
    setExlStyle(data) {
      let borderAll = {
        //单元格外侧框线
        top: {
          style: 'thin',
        },
        bottom: {
          style: 'thin',
        },
        left: {
          style: 'thin',
        },
        right: {
          style: 'thin',
        },
      }
      data['!cols'] = []
      for (let key in data) {
        if (data[key] instanceof Object) {
          data[key].s = {
            border: borderAll,
            alignment: {
              horizontal: 'center', //水平居中对齐
              vertical: 'center',
            },
            font: {
              sz: 11,
            },
            bold: true,
            numFmt: 0,
          }
          data['!cols'].push({ wpx: 200 })
        }
      }
      return data
    },
  },
  //生命周期 - 创建完成（可以访问当前 this 实例）
  created() {
    this.getMonitorPointId()
  },
  //生命周期 - 挂载完成（可以访问 DOM 元素）
  mounted() {},
  beforeCreate() {}, //生命周期 - 创建之前
  beforeMount() {}, //生命周期 - 挂载之前
  beforeUpdate() {}, //生命周期 - 更新之前
  updated() {}, //生命周期 - 更新之后
  beforeDestroy() {}, //生命周期 - 销毁之前
  destroyed() {}, //生命周期 - 销毁完成
  activated() {}, //如果页面有keep-alive缓存功能，这个函数会触发
}
</script>
<style scoped>
.zong {
  padding: 20px;
}
</style>